REVERSE_ALPHABET = {'A': 10, 'B': 11, 'C': 12, 'D': 13, 'E': 14, 'F': 15}
DIRECT_ALPHABET = {10: 'A', 11: 'B', 12: 'C', 13: 'D', 14: 'E', 15: 'F'}


def direct_convert(dex_number, system):
    number = ''

    while dex_number != 0:
        value = DIRECT_ALPHABET.get(dex_number % system, dex_number % system)
        dex_number, number = (dex_number // system), (number + f'{value}')

    return number[::-1]


def reverse_convert(number, system):
    dex_number, length = 0, len(str(number))

    for index, num in enumerate(str(number)):
        if num in REVERSE_ALPHABET: num = REVERSE_ALPHABET[num]
        num, index = int(num), length - (index + 1)
        dex_number += num * (system ** index)

    return dex_number


def convert(from_number, from_system, to_system):
    dex_number = reverse_convert(from_number, from_system)
    return direct_convert(dex_number, to_system)


def digital_convert(hvost, alf):
    digital_code = ''
    
    for char in hvost:
        charcode = alf.index(char)
        if charcode in DIRECT_ALPHABET:
            charcode = DIRECT_ALPHABET[charcode]

        digital_code += str(charcode)

    return digital_code


def get_word_by_code(code, alf):
    word = [alf[int(num)] for num in str(code)]
    return ''.join(word)
    

alf, result = input(), 0
a, b = list(map(int, input().split()))
hvost = digital_convert(input(), alf)
alf_system = len(set(alf))

if reverse_convert(hvost, alf_system) > b:
    print('Impossible')
elif hvost.startswith('0') and reverse_convert('1' + '0' * len(hvost), alf_system) > b:
    print('Impossible')
else:
    for x in range(int(b), int(a), -1):
        x = direct_convert(x, alf_system)
        if x.endswith(hvost):
            result = x
            break

    print(reverse_convert(result, alf_system), get_word_by_code(result, alf))
