REVERSE_ALPHABET = {'A': 10, 'B': 11, 'C': 12, 'D': 13, 'E': 14, 'F': 15}
DIRECT_ALPHABET = {10: 'A', 11: 'B', 12: 'C', 13: 'D', 14: 'E', 15: 'F'}


def direct_convert(dex_number, system):
    number = ''

    while dex_number != 0:
        value = DIRECT_ALPHABET.get(dex_number % system, dex_number % system)
        dex_number, number = (dex_number // system), (number + f'{value}')

    return number[::-1]


def reverse_convert(number, system):
    dex_number, length = 0, len(str(number))

    for index, num in enumerate(str(number)):
        if num in REVERSE_ALPHABET: num = REVERSE_ALPHABET[num]
        num, index = int(num), length - (index + 1)
        dex_number += num * (system ** index)

    return dex_number


def convert(from_number, from_system, to_system):
    dex_number = reverse_convert(from_number, from_system)
    return direct_convert(dex_number, to_system)


result = 0
for index_command in range(int(input())):
    command = direct_convert(int(input()), 13)
    for code in command:
        if code in REVERSE_ALPHABET:
            code = REVERSE_ALPHABET[code]

        if int(code) % 4 == 0:
            result += 1

print(result)
        
